int sensorValue = 0;
 
int sensorPinDown =A0; // sensor for holes connected to analog pin A0
int sensorPinUp = A1; // sensor for obstacles connected to analog pin A1
    int Limit_Distance_Sensor_Down = 82; // 82 = 1024 * 0.4V/5V
    int Limit_Distance_Sensor_Up = 153; // 205 = 1024 * 1V/5V
int liftedPin =A4; // Pin for sensor lift connected to analog pin A4
int motorPin = 6;    // PWM pin for the motor
int counter_pin_reset = 8; // to reset the counter
int counter_pin_blink = 7; // to increment the counter controlling the leds
int bipPin=9; // digital pin for sound
    int bip_short = 100; // length of a short bip in ms
    int bip_long = 400; // length of a long bip in ms
    int bip_delay = 75; // time to wait before the next letter in morse
 
int timeDelay = 100; // time delay (ms) to wait before restarting the loop
 

void setup() 
{                
  pinMode(sensorPinDown,INPUT); // analog pin for sensor as input
  pinMode(sensorPinUp,INPUT); //analog pin for sensor as input
  pinMode(motorPin, OUTPUT); // Pin for the motor as output
  pinMode(liftedPin, INPUT); // Pin for the lift captor as output
  pinMode(bipPin, OUTPUT);// pin for the sound as output

   // Initialisation of the counter 
  pinMode(counter_pin_blink, OUTPUT); 
  pinMode(counter_pin_reset, OUTPUT); 
  digitalWrite(counter_pin_reset, HIGH); 
  digitalWrite(counter_pin_reset, LOW); 
  digitalWrite(counter_pin_blink, LOW); 
  
}
 
void counter()  //function to increment the counter
{
          digitalWrite(counter_pin_blink, HIGH);
          delay(5);
          digitalWrite(counter_pin_blink, LOW); 
}
 
void sound(int time_sound) //serie of 3 sounds of the same length
{
          for (int i = 0; i<3; ++i)
            {
           digitalWrite(bipPin,HIGH);
           delay(time_sound);
           digitalWrite(bipPin,LOW);
           delay(bip_delay);
            }
}
void SOS() //function to bip SOS in morse code
     {  
       sound(bip_short);
       if (digitalRead(liftedPin)!=HIGH) // if someone does not lift Schizo
         {
             sound(bip_long);
             if (digitalRead(liftedPin)!=HIGH) 
             {
                 sound(bip_short);
                  if (digitalRead(liftedPin)!=HIGH)
                    delay(2000);
              }
         }
     }
void loop()
{
  if (digitalRead(liftedPin)==HIGH) // if someone lifts Schizo
  { 
    analogWrite(motorPin,0);    // Schizo stops 
    delay(500);
    while(liftedPin==HIGH) //Schizo waits while he is being lifted
    {delay(100);}
  }
  else if (analogRead(sensorPinUp) > Limit_Distance_Sensor_Up || analogRead(sensorPinDown) < Limit_Distance_Sensor_Down)  // if there is an obstacle or a hole in front
  {
    analogWrite(motorPin,0);    // Schizo stops 
    while (analogRead(sensorPinUp) > Limit_Distance_Sensor_Up || analogRead(sensorPinDown) < Limit_Distance_Sensor_Down)  // while there is an obstacle or a hole in front
    {
          SOS(); // Shizo asks for help;
          if (digitalRead(liftedPin)==HIGH) // if Schizo is being lifted
            {
              counter();                  // Increment the help counter
              break;
            }
    }
  }
  else
  { 
    analogWrite(motorPin,255);  // Schizo runs  
  } 
 delay(timeDelay);              // delay before restarting the loop
}